// GraphicsOptionsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "tulsa sample app.h"
#include "GraphicsOptionsDlg.h"
#include "GraphicsContentDlg.h"
#include "GraphicDebugInfo.h"
#include "hexddx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define SHIFT_KEY_IS_PRESSED()		((GetKeyState(VK_SHIFT) & 0x80) ? TRUE: FALSE)


/////////////////////////////////////////////////////////////////////////////
// CGraphicsOptionsDlg dialog

static BOOL bAutoApply = TRUE;

DWORD ZOrderChangeToDDFlag(int ZOrderListItem)
{
	switch(ZOrderListItem) {
	case 1:
		return(DDOVERZ_MOVEFORWARD | 0x80000000);
	case 2:
		return(DDOVERZ_MOVEBACKWARD | 0x80000000);
	case 3:
		return(DDOVERZ_SENDTOFRONT | 0x80000000);
	case 4:
		return(DDOVERZ_SENDTOBACK | 0x80000000);
	default:
		return(0);
	}
}


CGraphicsOptionsDlg::CGraphicsOptionsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGraphicsOptionsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGraphicsOptionsDlg)
	m_HScrollHeight = 0;
	m_HScrollWidth = 0;
	m_HScrollXPos = 0;
	m_HScrollYPos = 0;
	m_PriVideoHeight = 0;
	m_PriVideoWidth = 0;
	m_PriVideoXPos = 0;
	m_PriVideoYPos = 0;
	m_SecVideoHeight = 0;
	m_SecVideoWidth = 0;
	m_SecVideoXPos = 0;
	m_SecVideoYPos = 0;
	m_bShowHScroll = FALSE;
	m_bShowPriVideo = FALSE;
	m_bShowSecVideo = FALSE;
	m_bShowVScroll = FALSE;
	m_VScrollHeight = 0;
	m_VScrollWidth = 0;
	m_VScrollYPos = 0;
	m_VScrollXPos = 0;
	m_HScrollPixelsPerStep = 0;
	m_HScrollVerticalsPerStep = 0;
	m_VScrollPixelsPerStep = 0;
	m_VScrollVerticalsPerStep = 0;
	m_bAutoApply = bAutoApply;
	m_Ovly1Height = 0;
	m_Ovly1PixelsPerStep = 0;
	m_Ovly1Width = 0;
	m_Ovly1XPos = 0;
	m_Ovly1YPos = 0;
	m_bHScrollBlend = FALSE;
	m_bHScrollInvBlend = FALSE;
	m_bOvly1InvBlend = FALSE;
	m_bVScrollBlend = FALSE;
	m_bVScrollInvBlend = FALSE;
	m_bOvly1Blend = FALSE;
	m_bShowOvly1 = FALSE;
	m_bHScrollFilter = FALSE;
	m_bVScrollFilter = FALSE;
	m_Ovly1Filter = FALSE;
	m_bOvly1CkEnable = FALSE;
	m_Ovly1CkColor = 0;
	m_bBkGndFilter = FALSE;
	m_bShowBkGnd = FALSE;
	m_bBkGndUpdateAlpha = FALSE;
	m_bRGBVideoWriteAlpha = FALSE;
	m_bOvly1WriteAlpha = FALSE;
	m_bVScrollWriteAlpha = FALSE;
	m_bHScrollWriteAlpha = FALSE;
	m_bHorzGradient = FALSE;
	m_bVertGradient = FALSE;
	m_AlphaValue = 0;
	m_bInvertAlpha = FALSE;
	m_bTransitionAlpha = FALSE;
	m_AlphaTransitionVerts = 0;
	m_SettingDesc = _T("");
	//}}AFX_DATA_INIT

	m_pCardDlg = NULL;
	m_bDlgInitialized = FALSE;
	m_MouseCaptured = FALSE;

	m_RGBVideoZOrderFlags = 0;
	m_VScrollZOrderFlags = 0;
	m_HScrollZOrderFlags = 0;
	m_TitleOvlyZOrderFlags = 0;

	m_GrabInfo.GrabType = GRAB_NONE;
}


void CGraphicsOptionsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGraphicsOptionsDlg)
	DDX_Control(pDX, IDC_SELECTED_SETTING, m_EditSelectedSetting);
	DDX_Control(pDX, IDC_ALPHA_LEVEL_SLIDER, m_AlphaSlider);
	DDX_Text(pDX, IDC_HSCROLL_HEIGHT, m_HScrollHeight);
	DDV_MinMaxInt(pDX, m_HScrollHeight, 1, 720);
	DDX_Text(pDX, IDC_HSCROLL_WIDTH, m_HScrollWidth);
	DDV_MinMaxInt(pDX, m_HScrollWidth, 1, 720);
	DDX_Text(pDX, IDC_HSCROLL_XPOS, m_HScrollXPos);
	DDV_MinMaxInt(pDX, m_HScrollXPos, 0, 719);
	DDX_Text(pDX, IDC_HSCROLL_YPOS, m_HScrollYPos);
	DDV_MinMaxInt(pDX, m_HScrollYPos, 0, 575);
	DDX_Text(pDX, IDC_YUV_PRI_VID_HEIGHT, m_PriVideoHeight);
	DDV_MinMaxInt(pDX, m_PriVideoHeight, 1, 576);
	DDX_Text(pDX, IDC_YUV_PRI_VID_WIDTH, m_PriVideoWidth);
	DDV_MinMaxInt(pDX, m_PriVideoWidth, 1, 720);
	DDX_Text(pDX, IDC_YUV_PRI_VID_POS_X, m_PriVideoXPos);
	DDV_MinMaxInt(pDX, m_PriVideoXPos, 0, 719);
	DDX_Text(pDX, IDC_YUV_PRI_VID_POS_Y, m_PriVideoYPos);
	DDV_MinMaxInt(pDX, m_PriVideoYPos, 0, 575);
	DDX_Text(pDX, IDC_YUV_SEC_VID_POS_X, m_SecVideoXPos);
	DDV_MinMaxInt(pDX, m_SecVideoXPos, 0, 719);
	DDX_Text(pDX, IDC_YUV_SEC_VID_POS_Y, m_SecVideoYPos);
	DDV_MinMaxInt(pDX, m_SecVideoYPos, 0, 575);
	DDX_Check(pDX, IDC_SHOW_HSCROLL, m_bShowHScroll);
	DDX_Check(pDX, IDC_SHOW_YUV_PRI_VID, m_bShowPriVideo);
	DDX_Check(pDX, IDC_SHOW_YUV_SEC_VID, m_bShowSecVideo);
	DDX_Check(pDX, IDC_SHOW_VSCROLL, m_bShowVScroll);
	DDX_Text(pDX, IDC_VSCROLL_HEIGHT, m_VScrollHeight);
	DDV_MinMaxInt(pDX, m_VScrollHeight, 1, 576);
	DDX_Text(pDX, IDC_VSCROLL_WIDTH, m_VScrollWidth);
	DDV_MinMaxInt(pDX, m_VScrollWidth, 1, 720);
	DDX_Text(pDX, IDC_VSCROLL_YPOS, m_VScrollYPos);
	DDV_MinMaxInt(pDX, m_VScrollYPos, 0, 575);
	DDX_Text(pDX, IDC_VSCROLL_XPOS, m_VScrollXPos);
	DDV_MinMaxInt(pDX, m_VScrollXPos, 0, 719);
	DDX_Text(pDX, IDC_HSCROLL_PIXELS_PER_STEP, m_HScrollPixelsPerStep);
	DDV_MinMaxInt(pDX, m_HScrollPixelsPerStep, 1, 100);
	DDX_Text(pDX, IDC_HSCROLL_VERTICALS_PER_STEP, m_HScrollVerticalsPerStep);
	DDV_MinMaxInt(pDX, m_HScrollVerticalsPerStep, 1, 100);
	DDX_Text(pDX, IDC_VSCROLL_PIXELS_PER_STEP, m_VScrollPixelsPerStep);
	DDV_MinMaxInt(pDX, m_VScrollPixelsPerStep, 1, 100);
	DDX_Text(pDX, IDC_VSCROLL_VERTICALS_PER_STEP, m_VScrollVerticalsPerStep);
	DDV_MinMaxInt(pDX, m_VScrollVerticalsPerStep, 1, 100);
	DDX_Check(pDX, IDC_AUTO_APPLY, m_bAutoApply);
	DDX_Text(pDX, IDC_OVLY1_HEIGHT, m_Ovly1Height);
	DDX_Text(pDX, IDC_OVLY1_WIDTH, m_Ovly1Width);
	DDX_Text(pDX, IDC_OVLY1_XPOS, m_Ovly1XPos);
	DDX_Text(pDX, IDC_OVLY1_YPOS, m_Ovly1YPos);
	DDX_Check(pDX, IDC_HSCROLL_BLEND, m_bHScrollBlend);
	DDX_Check(pDX, IDC_HSCROLL_INV_BLEND, m_bHScrollInvBlend);
	DDX_Check(pDX, IDC_OVLY1_INV_BLEND, m_bOvly1InvBlend);
	DDX_Check(pDX, IDC_VSCROLL_BLEND, m_bVScrollBlend);
	DDX_Check(pDX, IDC_VSCROLL_INV_BLEND, m_bVScrollInvBlend);
	DDX_Check(pDX, IDC_OVLY1_BLEND, m_bOvly1Blend);
	DDX_Check(pDX, IDC_SHOW_OVLY1, m_bShowOvly1);
	DDX_Check(pDX, IDC_HSCROLL_FILTER, m_bHScrollFilter);
	DDX_Check(pDX, IDC_VSCROLL_FILTER, m_bVScrollFilter);
	DDX_Check(pDX, IDC_OVLY1_FILTER, m_Ovly1Filter);
	DDX_Check(pDX, IDC_OVLY1_CK_ENABLE, m_bOvly1CkEnable);
	DDX_Hex32Bit(pDX, IDC_OVLY1_CK_COLOR, m_Ovly1CkColor);
	DDX_Check(pDX, IDC_BKGND_FILTER, m_bBkGndFilter);
	DDX_Check(pDX, IDC_BKGND_SHOW, m_bShowBkGnd);
	DDX_Check(pDX, IDC_SHOW_RGB_VID, m_bShowRGBVideo);
	DDX_Text(pDX, IDC_RGB_VID_HEIGHT, m_RGBVideoHeight);
	DDV_MinMaxInt(pDX, m_RGBVideoHeight, 1, 576);
	DDX_Text(pDX, IDC_RGB_VID_WIDTH, m_RGBVideoWidth);
	DDV_MinMaxInt(pDX, m_RGBVideoWidth, 1, 720);
	DDX_Text(pDX, IDC_RGB_VID_POS_X, m_RGBVideoXPos);
	DDV_MinMaxInt(pDX, m_RGBVideoXPos, 0, 719);
	DDX_Text(pDX, IDC_RGB_VID_POS_Y, m_RGBVideoYPos);
	DDV_MinMaxInt(pDX, m_RGBVideoYPos, 0, 575);
	DDX_Text(pDX, IDC_YUV_PRI_VID_CROP_HEIGHT, m_PriVideoCropHeight);
	DDV_MinMaxInt(pDX, m_PriVideoCropHeight, 1, 576);
	DDX_Text(pDX, IDC_YUV_PRI_VID_CROP_WIDTH, m_PriVideoCropWidth);
	DDV_MinMaxInt(pDX, m_PriVideoCropWidth, 1, 720);
	DDX_Text(pDX, IDC_YUV_PRI_VID_CROP_X, m_PriVideoCropXPos);
	DDV_MinMaxInt(pDX, m_PriVideoCropXPos, 0, 719);
	DDX_Text(pDX, IDC_YUV_PRI_VID_CROP_Y, m_PriVideoCropYPos);
	DDV_MinMaxInt(pDX, m_PriVideoCropYPos, 0, 575);
	DDX_Text(pDX, IDC_YUV_SEC_VID_CROP_HEIGHT, m_SecVideoCropHeight);
	DDV_MinMaxInt(pDX, m_SecVideoCropHeight, 1, 576);
	DDX_Text(pDX, IDC_YUV_SEC_VID_CROP_WIDTH, m_SecVideoCropWidth);
	DDV_MinMaxInt(pDX, m_SecVideoCropWidth, 1, 720);
	DDX_Text(pDX, IDC_YUV_SEC_VID_CROP_X, m_SecVideoCropXPos);
	DDV_MinMaxInt(pDX, m_SecVideoCropXPos, 0, 719);
	DDX_Text(pDX, IDC_YUV_SEC_VID_CROP_Y, m_SecVideoCropYPos);
	DDV_MinMaxInt(pDX, m_SecVideoCropYPos, 0, 575);
	DDX_Text(pDX, IDC_RGB_VID_CROP_HEIGHT, m_RGBVideoCropHeight);
	DDV_MinMaxInt(pDX, m_RGBVideoCropHeight, 1, 576);
	DDX_Text(pDX, IDC_RGB_VID_CROP_WIDTH, m_RGBVideoCropWidth);
	DDV_MinMaxInt(pDX, m_RGBVideoCropWidth, 1, 720);
	DDX_Text(pDX, IDC_RGB_VID_CROP_X, m_RGBVideoCropXPos);
	DDV_MinMaxInt(pDX, m_RGBVideoCropXPos, 0, 719);
	DDX_Text(pDX, IDC_RGB_VID_CROP_Y, m_RGBVideoCropYPos);
	DDV_MinMaxInt(pDX, m_RGBVideoCropYPos, 0, 575);
	DDX_Check(pDX, IDC_BKGND_UPDATE_ALPHA, m_bBkGndUpdateAlpha);
	DDX_Check(pDX, IDC_RGB_VID_WRITE_ALPHA, m_bRGBVideoWriteAlpha);
	DDX_Check(pDX, IDC_OVLY1_WRITE_ALPHA, m_bOvly1WriteAlpha);
	DDX_Check(pDX, IDC_VSCROLL_WRITE_ALPHA, m_bVScrollWriteAlpha);
	DDX_Check(pDX, IDC_HSCROLL_WRITE_ALPHA, m_bHScrollWriteAlpha);
	DDX_Check(pDX, IDC_HORZ_GRADIENT, m_bHorzGradient);
	DDX_Check(pDX, IDC_VERT_GRADIENT, m_bVertGradient);
	DDX_Text(pDX, IDC_ALPHA_LEVEL, m_AlphaValue);
	DDX_Check(pDX, IDC_INV_ALPHA, m_bInvertAlpha);
	DDX_Check(pDX, IDC_TRANSITION_ALPHA, m_bTransitionAlpha);
	DDX_Text(pDX, IDC_ALPHA_TRANS_VERTS, m_AlphaTransitionVerts);
	DDX_Text(pDX, IDC_SETTING_DESC, m_SettingDesc);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGraphicsOptionsDlg, CDialog)
	//{{AFX_MSG_MAP(CGraphicsOptionsDlg)
	ON_BN_CLICKED(IDC_APPLY, OnApply)
	ON_EN_CHANGE(IDC_VSCROLL_PIXELS_PER_STEP, OnChange)
	ON_BN_CLICKED(IDC_AUTO_APPLY, OnAutoApply)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_BN_CLICKED(IDC_CONFIG1, OnConfig1)
	ON_BN_CLICKED(IDC_CONFIG2, OnConfig2)
	ON_BN_CLICKED(IDC_CONFIG3, OnConfig3)
	ON_BN_CLICKED(IDC_CONFIG4, OnConfig4)
	ON_BN_CLICKED(IDC_CONFIG5, OnConfig5)
	ON_BN_CLICKED(IDC_CONFIG6, OnConfig6)
	ON_BN_CLICKED(IDC_CONFIG7, OnConfig7)
	ON_BN_CLICKED(IDC_BKGND_SHOW, OnBkgndShow)
	ON_BN_CLICKED(IDC_Z_UP_RGB_VID, OnZUpRgbVid)
	ON_BN_CLICKED(IDC_Z_DN_RGB_VID, OnZDnRgbVid)
	ON_BN_CLICKED(IDC_Z_UP_TITLE, OnZUpTitle)
	ON_BN_CLICKED(IDC_Z_UP_VSCROLL, OnZUpVscroll)
	ON_BN_CLICKED(IDC_Z_UP_HSCROLL, OnZUpHscroll)
	ON_BN_CLICKED(IDC_Z_DN_HSCROLL, OnZDnHscroll)
	ON_BN_CLICKED(IDC_Z_DN_VSCROLL, OnZDnVscroll)
	ON_BN_CLICKED(IDC_Z_DN_TITLE, OnZDnTitle)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_VSCROLL_CONTENT, OnVscrollContent)
	ON_BN_CLICKED(IDC_HSCROLL_CONTENT, OnHscrollContent)
	ON_BN_CLICKED(IDC_BKGND_CONTENT, OnBkgndContent)
	ON_BN_CLICKED(IDC_OVLY1_CONTENT, OnOvly1Content)
	ON_EN_CHANGE(IDC_ALPHA_LEVEL, OnChangeAlphaLevel)
	ON_BN_CLICKED(IDC_DBG_INFO, OnDbgInfo)
	ON_BN_CLICKED(IDC_SAVE_PRESET, OnSavePreset)
	ON_BN_CLICKED(IDC_HORZ_GRADIENT, OnChange)
	ON_BN_CLICKED(IDC_VERT_GRADIENT, OnChange)
	ON_BN_CLICKED(IDC_SHOW_YUV_PRI_VID, OnChange)
	ON_BN_CLICKED(IDC_SHOW_YUV_SEC_VID, OnChange)
	ON_BN_CLICKED(IDC_SHOW_RGB_VID, OnChange)
	ON_EN_CHANGE(IDC_OVLY1_HEIGHT, OnChange)
	ON_EN_CHANGE(IDC_OVLY1_WIDTH, OnChange)
	ON_EN_CHANGE(IDC_OVLY1_XPOS, OnChange)
	ON_EN_CHANGE(IDC_OVLY1_YPOS, OnChange)
	ON_CBN_EDITCHANGE(IDC_OVLY1_ZORDER, OnChange)
	ON_EN_CHANGE(IDC_VSCROLL_VERTICALS_PER_STEP, OnChange)
	ON_BN_CLICKED(IDC_SHOW_VSCROLL, OnChange)
	ON_EN_CHANGE(IDC_VSCROLL_HEIGHT, OnChange)
	ON_EN_CHANGE(IDC_VSCROLL_WIDTH, OnChange)
	ON_EN_CHANGE(IDC_VSCROLL_XPOS, OnChange)
	ON_EN_CHANGE(IDC_VSCROLL_YPOS, OnChange)
	ON_CBN_EDITCHANGE(IDC_VSCROLL_ZORDER, OnChange)
	ON_EN_CHANGE(IDC_PRI_VIDEO_HEIGHT, OnChange)
	ON_EN_CHANGE(IDC_PRI_VIDEO_WIDTH, OnChange)
	ON_EN_CHANGE(IDC_PRI_VIDEO_XPOS, OnChange)
	ON_EN_CHANGE(IDC_PRI_VIDEO_YPOS, OnChange)
	ON_EN_CHANGE(IDC_SEC_VIDEO_HEIGHT, OnChange)
	ON_EN_CHANGE(IDC_SEC_VIDEO_WIDTH, OnChange)
	ON_EN_CHANGE(IDC_SEC_VIDEO_XPOS, OnChange)
	ON_EN_CHANGE(IDC_SEC_VIDEO_YPOS, OnChange)
	ON_BN_CLICKED(IDC_SHOW_PRI_VID, OnChange)
	ON_BN_CLICKED(IDC_SHOW_SEC_VID, OnChange)
	ON_BN_CLICKED(IDC_HSCROLL_BLEND, OnChange)
	ON_EN_CHANGE(IDC_HSCROLL_HEIGHT, OnChange)
	ON_BN_CLICKED(IDC_HSCROLL_INV_BLEND, OnChange)
	ON_EN_CHANGE(IDC_HSCROLL_PIXELS_PER_STEP, OnChange)
	ON_EN_CHANGE(IDC_HSCROLL_VERTICALS_PER_STEP, OnChange)
	ON_EN_CHANGE(IDC_HSCROLL_WIDTH, OnChange)
	ON_EN_CHANGE(IDC_HSCROLL_XPOS, OnChange)
	ON_EN_CHANGE(IDC_HSCROLL_YPOS, OnChange)
	ON_CBN_EDITCHANGE(IDC_HSCROLL_ZORDER, OnChange)
	ON_BN_CLICKED(IDC_OVLY1_BLEND, OnChange)
	ON_BN_CLICKED(IDC_OVLY1_INV_BLEND, OnChange)
	ON_CBN_EDITCHANGE(IDC_PRI_VIDEO_ZORDER, OnChange)
	ON_CBN_EDITCHANGE(IDC_SEC_VIDEO_ZORDER, OnChange)
	ON_BN_CLICKED(IDC_SHOW_HSCROLL, OnChange)
	ON_BN_CLICKED(IDC_SHOW_OVLY1, OnChange)
	ON_BN_CLICKED(IDC_VSCROLL_BLEND, OnChange)
	ON_BN_CLICKED(IDC_VSCROLL_INV_BLEND, OnChange)
	ON_BN_CLICKED(IDC_OVLY1_FILTER, OnChange)
	ON_BN_CLICKED(IDC_VSCROLL_FILTER, OnChange)
	ON_BN_CLICKED(IDC_HSCROLL_FILTER, OnChange)
	ON_CBN_SELCHANGE(IDC_PRI_VIDEO_ZORDER, OnChange)
	ON_BN_CLICKED(IDC_OVLY1_CK_ENABLE, OnChange)
	ON_EN_CHANGE(IDC_OVLY1_CK_COLOR, OnChange)
	ON_BN_CLICKED(IDC_BKGND_FILTER, OnChange)
	ON_EN_CHANGE(IDC_RGB_VID_CROP_HEIGHT, OnChange)
	ON_EN_CHANGE(IDC_RGB_VID_CROP_WIDTH, OnChange)
	ON_EN_CHANGE(IDC_RGB_VID_CROP_X, OnChange)
	ON_EN_CHANGE(IDC_RGB_VID_CROP_Y, OnChange)
	ON_EN_CHANGE(IDC_RGB_VID_HEIGHT, OnChange)
	ON_EN_CHANGE(IDC_RGB_VID_POS_X, OnChange)
	ON_EN_CHANGE(IDC_RGB_VID_POS_Y, OnChange)
	ON_EN_CHANGE(IDC_RGB_VID_WIDTH, OnChange)
	ON_EN_CHANGE(IDC_YUV_PRI_VID_CROP_HEIGHT, OnChange)
	ON_EN_CHANGE(IDC_YUV_PRI_VID_CROP_WIDTH, OnChange)
	ON_EN_CHANGE(IDC_YUV_PRI_VID_CROP_X, OnChange)
	ON_EN_CHANGE(IDC_YUV_PRI_VID_CROP_Y, OnChange)
	ON_EN_CHANGE(IDC_YUV_PRI_VID_HEIGHT, OnChange)
	ON_EN_CHANGE(IDC_YUV_PRI_VID_POS_X, OnChange)
	ON_EN_CHANGE(IDC_YUV_PRI_VID_POS_Y, OnChange)
	ON_EN_CHANGE(IDC_YUV_PRI_VID_WIDTH, OnChange)
	ON_EN_CHANGE(IDC_YUV_SEC_VID_CROP_HEIGHT, OnChange)
	ON_EN_CHANGE(IDC_YUV_SEC_VID_CROP_WIDTH, OnChange)
	ON_EN_CHANGE(IDC_YUV_SEC_VID_CROP_X, OnChange)
	ON_EN_CHANGE(IDC_YUV_SEC_VID_CROP_Y, OnChange)
	ON_EN_CHANGE(IDC_YUV_SEC_VID_POS_X, OnChange)
	ON_EN_CHANGE(IDC_YUV_SEC_VID_POS_Y, OnChange)
	ON_BN_CLICKED(IDC_INV_ALPHA, OnChange)
	ON_BN_CLICKED(IDC_RGB_VID_WRITE_ALPHA, OnChange)
	ON_BN_CLICKED(IDC_OVLY1_WRITE_ALPHA, OnChange)
	ON_BN_CLICKED(IDC_BKGND_UPDATE_ALPHA, OnChange)
	ON_BN_CLICKED(IDC_HSCROLL_WRITE_ALPHA, OnChange)
	ON_BN_CLICKED(IDC_TRANSITION_ALPHA, OnChange)
	ON_BN_CLICKED(IDC_VSCROLL_WRITE_ALPHA, OnChange)
	ON_BN_CLICKED(IDC_CONFIG8, OnConfig8)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGraphicsOptionsDlg message handlers

void CGraphicsOptionsDlg::OnApply() 
{
	if (!m_bDlgInitialized) {
		return;
	}
	if (m_pCardDlg == NULL) {
		return;
	}

	UpdateData(TRUE);
	m_pCardDlg->pYUVPriVideoOvly->m_bShow = m_bShowPriVideo;
	m_pCardDlg->pYUVPriVideoOvly->m_Size = CSize(m_PriVideoWidth, m_PriVideoHeight);
	m_pCardDlg->pYUVPriVideoOvly->m_Position = CPoint(m_PriVideoXPos, m_PriVideoYPos);
	m_pCardDlg->pYUVPriVideoOvly->m_SrcCropSize = CSize(m_PriVideoCropWidth, m_PriVideoCropHeight);
	m_pCardDlg->pYUVPriVideoOvly->m_SrcCropPosition = CPoint(m_PriVideoCropXPos, m_PriVideoCropYPos);

	m_pCardDlg->pYUVSecVideoOvly->m_bShow = m_bShowSecVideo;
	m_pCardDlg->pYUVSecVideoOvly->m_Size = CSize(m_SecVideoWidth, m_SecVideoHeight);
	m_pCardDlg->pYUVSecVideoOvly->m_Position = CPoint(m_SecVideoXPos, m_SecVideoYPos);
	m_pCardDlg->pYUVSecVideoOvly->m_SrcCropSize = CSize(m_SecVideoCropWidth, m_SecVideoCropHeight);
	m_pCardDlg->pYUVSecVideoOvly->m_SrcCropPosition = CPoint(m_SecVideoCropXPos, m_SecVideoCropYPos);

	m_pCardDlg->pRGBVideoOvly->m_bShow = m_bShowRGBVideo;
	m_pCardDlg->pRGBVideoOvly->m_Size = CSize(m_RGBVideoWidth, m_RGBVideoHeight);
	m_pCardDlg->pRGBVideoOvly->m_Position = CPoint(m_RGBVideoXPos, m_RGBVideoYPos);
	m_pCardDlg->pRGBVideoOvly->m_SrcCropSize = CSize(m_RGBVideoCropWidth, m_RGBVideoCropHeight);
	m_pCardDlg->pRGBVideoOvly->m_SrcCropPosition = CPoint(m_RGBVideoCropXPos, m_RGBVideoCropYPos);
	m_pCardDlg->pRGBVideoOvly->m_bWriteAlpha = m_bRGBVideoWriteAlpha;

	m_pCardDlg->pVScrollOvly->m_bShow = m_bShowVScroll;
	m_pCardDlg->pVScrollOvly->m_Size = CSize(m_VScrollWidth, m_VScrollHeight);
	m_pCardDlg->pVScrollOvly->m_Position = CPoint(m_VScrollXPos, m_VScrollYPos);
	m_pCardDlg->pVScrollOvly->m_bBlend = m_bVScrollBlend;
	m_pCardDlg->pVScrollOvly->m_bInvBlend = m_bVScrollInvBlend;
	m_pCardDlg->pVScrollOvly->m_PixelsPerStep = m_VScrollPixelsPerStep;
	m_pCardDlg->pVScrollOvly->m_VerticalsPerStep = m_VScrollVerticalsPerStep;
	m_pCardDlg->pVScrollOvly->m_bFilter = m_bVScrollFilter;
	m_pCardDlg->pVScrollOvly->m_bWriteAlpha = m_bVScrollWriteAlpha;

	m_pCardDlg->pHScrollOvly->m_bShow = m_bShowHScroll;
	m_pCardDlg->pHScrollOvly->m_Size = CSize(m_HScrollWidth, m_HScrollHeight);
	m_pCardDlg->pHScrollOvly->m_Position = CPoint(m_HScrollXPos, m_HScrollYPos);
	m_pCardDlg->pHScrollOvly->m_bBlend = m_bHScrollBlend;
	m_pCardDlg->pHScrollOvly->m_bInvBlend = m_bHScrollInvBlend;
	m_pCardDlg->pHScrollOvly->m_PixelsPerStep = m_HScrollPixelsPerStep;
	m_pCardDlg->pHScrollOvly->m_VerticalsPerStep = m_HScrollVerticalsPerStep;
	m_pCardDlg->pHScrollOvly->m_bFilter = m_bHScrollFilter;
	m_pCardDlg->pHScrollOvly->m_bWriteAlpha = m_bHScrollWriteAlpha;

	m_pCardDlg->pTitleOvly->m_bShow = m_bShowOvly1;
	m_pCardDlg->pTitleOvly->m_Size = CSize(m_Ovly1Width, m_Ovly1Height);
	m_pCardDlg->pTitleOvly->m_Position = CPoint(m_Ovly1XPos, m_Ovly1YPos);
	m_pCardDlg->pTitleOvly->m_bBlend = m_bOvly1Blend;
	m_pCardDlg->pTitleOvly->m_bInvBlend = m_bOvly1InvBlend;
	m_pCardDlg->pTitleOvly->m_bFilter = m_Ovly1Filter;
	m_pCardDlg->pTitleOvly->m_bCkEnable = m_bOvly1CkEnable;
	m_pCardDlg->pTitleOvly->m_CkColor = m_Ovly1CkColor;
	m_pCardDlg->pTitleOvly->m_bWriteAlpha = m_bOvly1WriteAlpha;

	m_pCardDlg->bBackGndFlickerFilter = m_bBkGndFilter;
	m_pCardDlg->bShowBackGnd = m_bShowBkGnd;
	m_pCardDlg->bBkGndUpdateAlpha = m_bBkGndUpdateAlpha;

	m_pCardDlg->AlphaOptions.AlphaValue = m_AlphaValue;
	m_pCardDlg->AlphaOptions.bHorzGradient = m_bHorzGradient;
	m_pCardDlg->AlphaOptions.bVertGradient = m_bVertGradient;
	m_pCardDlg->AlphaOptions.bInvertAlpha = m_bInvertAlpha;
	m_pCardDlg->AlphaOptions.bTransitionAlpha = m_bTransitionAlpha;
	m_pCardDlg->AlphaOptions.TransitionVerticals = m_AlphaTransitionVerts;

	m_pCardDlg->RGBVideoZOrderFlags = m_RGBVideoZOrderFlags;
	m_pCardDlg->VScrollZOrderFlags = m_VScrollZOrderFlags;
	m_pCardDlg->HScrollZOrderFlags = m_HScrollZOrderFlags;
	m_pCardDlg->TitleOvlyZOrderFlags = m_TitleOvlyZOrderFlags;

	switch(GetCheckedRadioButton(IDC_VID_MODE_NTSC, IDC_VID_MODE_PAL)) {
	case IDC_VID_MODE_PAL:
		m_pCardDlg->m_VideoMode = VIDEO_MODE_PAL;
		break;
	case IDC_VID_MODE_NTSC:
	default:
		m_pCardDlg->m_VideoMode = VIDEO_MODE_NTSC;
		break;
	}


	m_pCardDlg->ApplyGraphicsSettings();

	m_RGBVideoZOrderFlags = 0;
	m_VScrollZOrderFlags = 0;
	m_HScrollZOrderFlags = 0;
	m_TitleOvlyZOrderFlags = 0;

}

void CGraphicsOptionsDlg::InitControls()
{
	m_SettingDesc = m_pCardDlg->m_szPresetDesc;
	SetDlgItemInt(IDC_SELECTED_SETTING, m_pCardDlg->m_ConfigPreset + 1, FALSE);

	m_bShowPriVideo = m_pCardDlg->pYUVPriVideoOvly->m_bShow;
	m_PriVideoWidth = m_pCardDlg->pYUVPriVideoOvly->m_Size.cx;
	m_PriVideoHeight = m_pCardDlg->pYUVPriVideoOvly->m_Size.cy;
	m_PriVideoXPos = m_pCardDlg->pYUVPriVideoOvly->m_Position.x;
	m_PriVideoYPos = m_pCardDlg->pYUVPriVideoOvly->m_Position.y;
	m_PriVideoCropWidth = m_pCardDlg->pYUVPriVideoOvly->m_SrcCropSize.cx;
	m_PriVideoCropHeight = m_pCardDlg->pYUVPriVideoOvly->m_SrcCropSize.cy;
	m_PriVideoCropXPos = m_pCardDlg->pYUVPriVideoOvly->m_SrcCropPosition.x; 
	m_PriVideoCropYPos = m_pCardDlg->pYUVPriVideoOvly->m_SrcCropPosition.y;
	
	m_bShowSecVideo = m_pCardDlg->pYUVSecVideoOvly->m_bShow;
	m_SecVideoWidth = m_pCardDlg->pYUVSecVideoOvly->m_Size.cx;
	m_SecVideoHeight = m_pCardDlg->pYUVSecVideoOvly->m_Size.cy;
	m_SecVideoXPos = m_pCardDlg->pYUVSecVideoOvly->m_Position.x;
	m_SecVideoYPos = m_pCardDlg->pYUVSecVideoOvly->m_Position.y;
	m_SecVideoCropWidth = m_pCardDlg->pYUVSecVideoOvly->m_SrcCropSize.cx;
	m_SecVideoCropHeight = m_pCardDlg->pYUVSecVideoOvly->m_SrcCropSize.cy;
	m_SecVideoCropXPos = m_pCardDlg->pYUVSecVideoOvly->m_SrcCropPosition.x; 
	m_SecVideoCropYPos = m_pCardDlg->pYUVSecVideoOvly->m_SrcCropPosition.y;

	m_bShowRGBVideo = m_pCardDlg->pRGBVideoOvly->m_bShow;
	m_RGBVideoWidth = m_pCardDlg->pRGBVideoOvly->m_Size.cx;
	m_RGBVideoHeight = m_pCardDlg->pRGBVideoOvly->m_Size.cy;
	m_RGBVideoXPos = m_pCardDlg->pRGBVideoOvly->m_Position.x;
	m_RGBVideoYPos = m_pCardDlg->pRGBVideoOvly->m_Position.y;
	m_RGBVideoCropWidth = m_pCardDlg->pRGBVideoOvly->m_SrcCropSize.cx;
	m_RGBVideoCropHeight = m_pCardDlg->pRGBVideoOvly->m_SrcCropSize.cy;
	m_RGBVideoCropXPos = m_pCardDlg->pRGBVideoOvly->m_SrcCropPosition.x; 
	m_RGBVideoCropYPos = m_pCardDlg->pRGBVideoOvly->m_SrcCropPosition.y;

	m_bShowVScroll = m_pCardDlg->pVScrollOvly->m_bShow;
	m_VScrollWidth = m_pCardDlg->pVScrollOvly->m_Size.cx;
	m_VScrollHeight = m_pCardDlg->pVScrollOvly->m_Size.cy;
	m_VScrollXPos = m_pCardDlg->pVScrollOvly->m_Position.x; 
	m_VScrollYPos = m_pCardDlg->pVScrollOvly->m_Position.y;
	m_bVScrollBlend = m_pCardDlg->pVScrollOvly->m_bBlend;
	m_bVScrollInvBlend = m_pCardDlg->pVScrollOvly->m_bInvBlend;
	m_VScrollPixelsPerStep = m_pCardDlg->pVScrollOvly->m_PixelsPerStep;
	m_VScrollVerticalsPerStep = m_pCardDlg->pVScrollOvly->m_VerticalsPerStep;
	m_bVScrollFilter = m_pCardDlg->pVScrollOvly->m_bFilter;
	m_bVScrollWriteAlpha = m_pCardDlg->pVScrollOvly->m_bWriteAlpha;

	m_bShowHScroll = m_pCardDlg->pHScrollOvly->m_bShow;
	m_HScrollWidth = m_pCardDlg->pHScrollOvly->m_Size.cx;
	m_HScrollHeight = m_pCardDlg->pHScrollOvly->m_Size.cy;
	m_HScrollXPos = m_pCardDlg->pHScrollOvly->m_Position.x;
	m_HScrollYPos = m_pCardDlg->pHScrollOvly->m_Position.y;
	m_bHScrollBlend = m_pCardDlg->pHScrollOvly->m_bBlend;
	m_bHScrollInvBlend = m_pCardDlg->pHScrollOvly->m_bInvBlend;
	m_HScrollPixelsPerStep = m_pCardDlg->pHScrollOvly->m_PixelsPerStep;
	m_HScrollVerticalsPerStep = m_pCardDlg->pHScrollOvly->m_VerticalsPerStep;
	m_bHScrollFilter = m_pCardDlg->pHScrollOvly->m_bFilter;
	m_bHScrollWriteAlpha = m_pCardDlg->pHScrollOvly->m_bWriteAlpha;

	m_bShowOvly1 = m_pCardDlg->pTitleOvly->m_bShow;
	m_Ovly1Width = m_pCardDlg->pTitleOvly->m_Size.cx;
	m_Ovly1Height = m_pCardDlg->pTitleOvly->m_Size.cy;
	m_Ovly1XPos = m_pCardDlg->pTitleOvly->m_Position.x;
	m_Ovly1YPos = m_pCardDlg->pTitleOvly->m_Position.y;
	m_bOvly1Blend = m_pCardDlg->pTitleOvly->m_bBlend;
	m_bOvly1InvBlend = m_pCardDlg->pTitleOvly->m_bInvBlend;
	m_Ovly1Filter = m_pCardDlg->pTitleOvly->m_bFilter;
	m_bOvly1CkEnable = m_pCardDlg->pTitleOvly->m_bCkEnable;
	m_Ovly1CkColor = m_pCardDlg->pTitleOvly->m_CkColor;
	m_bOvly1WriteAlpha = m_pCardDlg->pTitleOvly->m_bWriteAlpha;

	m_bBkGndFilter = m_pCardDlg->bBackGndFlickerFilter;
	m_bShowBkGnd = m_pCardDlg->bShowBackGnd;
	m_bBkGndUpdateAlpha = m_pCardDlg->bBkGndUpdateAlpha;

	m_AlphaValue = m_pCardDlg->AlphaOptions.AlphaValue;
	m_bHorzGradient = m_pCardDlg->AlphaOptions.bHorzGradient;
	m_bVertGradient = m_pCardDlg->AlphaOptions.bVertGradient;
	m_bInvertAlpha = m_pCardDlg->AlphaOptions.bInvertAlpha;
	m_bTransitionAlpha = m_pCardDlg->AlphaOptions.bTransitionAlpha;
	m_AlphaTransitionVerts = m_pCardDlg->AlphaOptions.TransitionVerticals;

	m_AlphaSlider.SetPos(m_AlphaValue);

	switch(m_pCardDlg->m_VideoMode) {
	case VIDEO_MODE_PAL:
		CheckRadioButton(IDC_VID_MODE_NTSC, IDC_VID_MODE_PAL, IDC_VID_MODE_PAL);
		break;
	case VIDEO_MODE_NTSC:
	default:
		CheckRadioButton(IDC_VID_MODE_NTSC, IDC_VID_MODE_PAL, IDC_VID_MODE_NTSC);
		break;
	}


	UpdateData(FALSE);
}

BOOL CGraphicsOptionsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	CSpinButtonCtrl *pSpin = (CSpinButtonCtrl*)GetDlgItem(IDC_VSCROLL_RATE_SPIN1);
	pSpin->SetRange(100, 1);
	pSpin = (CSpinButtonCtrl*)GetDlgItem(IDC_VSCROLL_RATE_SPIN2);
	pSpin->SetRange(100, 1);

	pSpin = (CSpinButtonCtrl*)GetDlgItem(IDC_HSCROLL_RATE_SPIN1);
	pSpin->SetRange(100, 1);
	pSpin = (CSpinButtonCtrl*)GetDlgItem(IDC_HSCROLL_RATE_SPIN2);
	pSpin->SetRange(100, 1);

	InitControls();

	m_AlphaSlider.SetRange(0, 255, TRUE);

	UpdateData(FALSE);

	m_AlphaSlider.SetPos(m_AlphaValue);


	m_bDlgInitialized = TRUE;

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CGraphicsOptionsDlg::OnOK() 
{
	bAutoApply = m_bAutoApply;
	OnApply();
	
	CDialog::OnOK();
}


void CGraphicsOptionsDlg::OnAutoApply() 
{
	CButton *pButton = (CButton*)GetDlgItem(IDC_AUTO_APPLY);
	m_bAutoApply = pButton->GetCheck() == 1? TRUE: FALSE;
}

void CGraphicsOptionsDlg::OnChange() 
{
	if (m_bAutoApply) {
		OnApply();
	}
}

void CGraphicsOptionsDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	if (m_MouseCaptured) {
		CPoint NewDelta;
		NewDelta = point - m_GrabInfo.CapturePoint;
		m_GrabInfo.CapturePoint = point;

		if (m_GrabInfo.GrabType == GRAB_MOVE) {
			*m_GrabInfo.pXPos += NewDelta.x;
			*m_GrabInfo.pYPos += NewDelta.y;

			if (*m_GrabInfo.pXPos + *m_GrabInfo.pWidth > 719) {
				*m_GrabInfo.pXPos = 719 - *m_GrabInfo.pWidth;
			}
			if (*m_GrabInfo.pXPos < 0) {
				*m_GrabInfo.pXPos = 0;	
			}

			if (*m_GrabInfo.pYPos + *m_GrabInfo.pHeight > m_GrabInfo.HeightMax) {
				*m_GrabInfo.pYPos = m_GrabInfo.HeightMax - *m_GrabInfo.pHeight;
			}
			if (*m_GrabInfo.pYPos < 0) {
				*m_GrabInfo.pYPos = 0;
			}

			*m_GrabInfo.pXValueUpdate = *m_GrabInfo.pXPos;
			*m_GrabInfo.pYValueUpdate = *m_GrabInfo.pYPos;

		} else if (m_GrabInfo.GrabType == GRAB_SIZE) {
			*m_GrabInfo.pWidth += NewDelta.x;
			*m_GrabInfo.pHeight += NewDelta.y;

			if (*m_GrabInfo.pXPos + *m_GrabInfo.pWidth > 719) {
				*m_GrabInfo.pWidth = 719 - *m_GrabInfo.pXPos;
			}
			if (*m_GrabInfo.pWidth < 0) {
				*m_GrabInfo.pWidth = 0;	
			}

			if (*m_GrabInfo.pYPos + *m_GrabInfo.pHeight > m_GrabInfo.HeightMax) {
				*m_GrabInfo.pHeight = m_GrabInfo.HeightMax - *m_GrabInfo.pYPos;
			}
			if (*m_GrabInfo.pHeight < 0) {
				*m_GrabInfo.pHeight = 0;
			}

			*m_GrabInfo.pXValueUpdate = *m_GrabInfo.pWidth;
			*m_GrabInfo.pYValueUpdate = *m_GrabInfo.pHeight;

		}
		UpdateData(FALSE);
		m_pCardDlg->ApplyGraphicsSettings();
		return;
	}
	CDialog::OnMouseMove(nFlags, point);
}

BOOL CGraphicsOptionsDlg::PointInWindow(int ID, CPoint point)
{
	CRect RectItem;
	CRect RectDlg;
	CWnd *pWnd;

	pWnd = (CWnd*)GetDlgItem(ID);
	pWnd->GetWindowRect(&RectItem);
	GetWindowRect(&RectDlg);
	RectItem -= RectDlg.TopLeft();
	if (RectItem.PtInRect(point)) {
		return(TRUE);
	}
	return(FALSE);

}

void CGraphicsOptionsDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CPoint OrigPoint = point;
	point.y += GetSystemMetrics(SM_CYSIZE);
	if (PointInWindow(IDC_YUV_SEC_VID_GRAB_POS, point)) {
		m_GrabInfo.GrabType = GRAB_MOVE;
		m_GrabInfo.pXPos = &m_SecVideoXPos;
		m_GrabInfo.pYPos = &m_SecVideoYPos;
		m_GrabInfo.pWidth = &m_SecVideoWidth;
		m_GrabInfo.pHeight = &m_SecVideoHeight;
		m_GrabInfo.pXValueUpdate = &m_pCardDlg->pYUVSecVideoOvly->m_Position.x;
		m_GrabInfo.pYValueUpdate = &m_pCardDlg->pYUVSecVideoOvly->m_Position.y;
	} else if (PointInWindow(IDC_YUV_PRI_VID_GRAB_SIZE, point)) {
		m_GrabInfo.GrabType = GRAB_SIZE;
		m_GrabInfo.pXPos = &m_PriVideoXPos;
		m_GrabInfo.pYPos = &m_PriVideoYPos;
		m_GrabInfo.pWidth = &m_PriVideoWidth;
		m_GrabInfo.pHeight = &m_PriVideoHeight;
		m_GrabInfo.pXValueUpdate = &m_pCardDlg->pYUVPriVideoOvly->m_Size.cx;
		m_GrabInfo.pYValueUpdate = &m_pCardDlg->pYUVPriVideoOvly->m_Size.cy;
	} else if (PointInWindow(IDC_YUV_PRI_VID_GRAB_POS, point)) {
		m_GrabInfo.GrabType = GRAB_MOVE;
		m_GrabInfo.pXPos = &m_PriVideoXPos;
		m_GrabInfo.pYPos = &m_PriVideoYPos;
		m_GrabInfo.pWidth = &m_PriVideoWidth;
		m_GrabInfo.pHeight = &m_PriVideoHeight;
		m_GrabInfo.pXValueUpdate = &m_pCardDlg->pYUVPriVideoOvly->m_Position.x;
		m_GrabInfo.pYValueUpdate = &m_pCardDlg->pYUVPriVideoOvly->m_Position.y;
	} else if (PointInWindow(IDC_RGB_VIDEO_GRAB_SIZE, point)) {
		m_GrabInfo.GrabType = GRAB_SIZE;
		m_GrabInfo.pXPos = &m_RGBVideoXPos;
		m_GrabInfo.pYPos = &m_RGBVideoYPos;
		m_GrabInfo.pWidth = &m_RGBVideoWidth;
		m_GrabInfo.pHeight = &m_RGBVideoHeight;
		m_GrabInfo.pXValueUpdate = &m_pCardDlg->pRGBVideoOvly->m_Size.cx;
		m_GrabInfo.pYValueUpdate = &m_pCardDlg->pRGBVideoOvly->m_Size.cy;
	} else if (PointInWindow(IDC_RGB_VIDEO_GRAB_POS, point)) {
		m_GrabInfo.GrabType = GRAB_MOVE;
		m_GrabInfo.pXPos = &m_RGBVideoXPos;
		m_GrabInfo.pYPos = &m_RGBVideoYPos;
		m_GrabInfo.pWidth = &m_RGBVideoWidth;
		m_GrabInfo.pHeight = &m_RGBVideoHeight;
		m_GrabInfo.pXValueUpdate = &m_pCardDlg->pRGBVideoOvly->m_Position.x;
		m_GrabInfo.pYValueUpdate = &m_pCardDlg->pRGBVideoOvly->m_Position.y;
	} else if (PointInWindow(IDC_VSCROLL_GRAB_SIZE, point)) {
		m_GrabInfo.GrabType = GRAB_SIZE;
		m_GrabInfo.pXPos = &m_VScrollXPos;
		m_GrabInfo.pYPos = &m_VScrollYPos;
		m_GrabInfo.pWidth = &m_VScrollWidth;
		m_GrabInfo.pHeight = &m_VScrollHeight;
		m_GrabInfo.pXValueUpdate = &m_pCardDlg->pVScrollOvly->m_Size.cx;
		m_GrabInfo.pYValueUpdate = &m_pCardDlg->pVScrollOvly->m_Size.cy;
	} else if (PointInWindow(IDC_VSCROLL_GRAB_POS, point)) {
		m_GrabInfo.GrabType = GRAB_MOVE;
		m_GrabInfo.pXPos = &m_VScrollXPos;
		m_GrabInfo.pYPos = &m_VScrollYPos;
		m_GrabInfo.pWidth = &m_VScrollWidth;
		m_GrabInfo.pHeight = &m_VScrollHeight;
		m_GrabInfo.pXValueUpdate = &m_pCardDlg->pVScrollOvly->m_Position.x;
		m_GrabInfo.pYValueUpdate = &m_pCardDlg->pVScrollOvly->m_Position.y;
	} else if (PointInWindow(IDC_HSCROLL_GRAB_POS, point)) {
		m_GrabInfo.GrabType = GRAB_MOVE;
		m_GrabInfo.pXPos = &m_HScrollXPos;
		m_GrabInfo.pYPos = &m_HScrollYPos;
		m_GrabInfo.pWidth = &m_HScrollWidth;
		m_GrabInfo.pHeight = &m_HScrollHeight;
		m_GrabInfo.pXValueUpdate = &m_pCardDlg->pHScrollOvly->m_Position.x;
		m_GrabInfo.pYValueUpdate = &m_pCardDlg->pHScrollOvly->m_Position.y;
	} else if (PointInWindow(IDC_HSCROLL_GRAB_SIZE, point)) {
		m_GrabInfo.GrabType = GRAB_SIZE;
		m_GrabInfo.pXPos = &m_HScrollXPos;
		m_GrabInfo.pYPos = &m_HScrollYPos;
		m_GrabInfo.pWidth = &m_HScrollWidth;
		m_GrabInfo.pHeight = &m_HScrollHeight;
		m_GrabInfo.pXValueUpdate = &m_pCardDlg->pHScrollOvly->m_Size.cx;
		m_GrabInfo.pYValueUpdate = &m_pCardDlg->pHScrollOvly->m_Size.cy;
	} else if (PointInWindow(IDC_OVLY1_GRAB_POS, point)) {
		m_GrabInfo.GrabType = GRAB_MOVE;
		m_GrabInfo.pXPos = &m_Ovly1XPos;
		m_GrabInfo.pYPos = &m_Ovly1YPos;
		m_GrabInfo.pWidth = &m_Ovly1Width;
		m_GrabInfo.pHeight = &m_Ovly1Height;
		m_GrabInfo.pXValueUpdate = &m_pCardDlg->pTitleOvly->m_Position.x;
		m_GrabInfo.pYValueUpdate = &m_pCardDlg->pTitleOvly->m_Position.y;
	} else if (PointInWindow(IDC_OVLY1_GRAB_SIZE, point)) {
		m_GrabInfo.GrabType = GRAB_SIZE;
		m_GrabInfo.pXPos = &m_Ovly1XPos;
		m_GrabInfo.pYPos = &m_Ovly1YPos;
		m_GrabInfo.pWidth = &m_Ovly1Width;
		m_GrabInfo.pHeight = &m_Ovly1Height;
		m_GrabInfo.pXValueUpdate = &m_pCardDlg->pTitleOvly->m_Size.cx;
		m_GrabInfo.pYValueUpdate = &m_pCardDlg->pTitleOvly->m_Size.cy;
	} else {
		CDialog::OnLButtonDown(nFlags, point);
		return;
	}

	if (m_pCardDlg->m_VideoMode == VIDEO_MODE_NTSC) {
		m_GrabInfo.HeightMax = 480;
	} else {
		m_GrabInfo.HeightMax = 480;
	}
	m_MouseCaptured = TRUE;
	m_GrabInfo.CapturePoint = OrigPoint;

	SetCapture();
}

void CGraphicsOptionsDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	if (m_MouseCaptured) {
		m_MouseCaptured = FALSE;
		ReleaseCapture();
	}
	
	CDialog::OnLButtonUp(nFlags, point);
}


void CGraphicsOptionsDlg::UsePresetConfig(int PresetNum)
{
	if (m_pCardDlg == NULL) {
		return;
	}
	m_pCardDlg->DisableGraphicsSettings();
	m_pCardDlg->UsePreset(PresetNum);
	m_bDlgInitialized = FALSE;
	InitControls();
	m_bDlgInitialized = TRUE;
	m_pCardDlg->ApplyGraphicsSettings();
}

void CGraphicsOptionsDlg::OnConfig1() 
{
	if (SHIFT_KEY_IS_PRESSED()) {
		m_pCardDlg->SavePreset(0);	
	} else {
		UsePresetConfig(0);	
	}
}

void CGraphicsOptionsDlg::OnConfig2() 
{
	if (SHIFT_KEY_IS_PRESSED()) {
		m_pCardDlg->SavePreset(1);	
	} else {
		UsePresetConfig(1);	
	}
}

void CGraphicsOptionsDlg::OnConfig3() 
{
	if (SHIFT_KEY_IS_PRESSED()) {
		m_pCardDlg->SavePreset(2);	
	} else {
		UsePresetConfig(2);	
	}
}

void CGraphicsOptionsDlg::OnConfig4() 
{
	if (SHIFT_KEY_IS_PRESSED()) {
		m_pCardDlg->SavePreset(3);	
	} else {
		UsePresetConfig(3);	
	}
}

void CGraphicsOptionsDlg::OnConfig5() 
{
	if (SHIFT_KEY_IS_PRESSED()) {
		m_pCardDlg->SavePreset(4);	
	} else {
		UsePresetConfig(4);	
	}
}

void CGraphicsOptionsDlg::OnConfig6() 
{
	if (SHIFT_KEY_IS_PRESSED()) {
		m_pCardDlg->SavePreset(5);	
	} else {
		UsePresetConfig(5);	
	}
}

void CGraphicsOptionsDlg::OnConfig7() 
{
	if (SHIFT_KEY_IS_PRESSED()) {
		m_pCardDlg->SavePreset(6);	
	} else {
		UsePresetConfig(6);	
	}
}

void CGraphicsOptionsDlg::OnConfig8() 
{
	if (SHIFT_KEY_IS_PRESSED()) {
		m_pCardDlg->SavePreset(7);	
	} else {
		UsePresetConfig(7);	
	}
}




void CGraphicsOptionsDlg::OnBkgndShow() 
{
	
}

void CGraphicsOptionsDlg::OnZUpRgbVid() 
{
	m_RGBVideoZOrderFlags = DDOVERZ_MOVEFORWARD | 0x80000000;
	UpdateData(FALSE);
	OnChange();
}

void CGraphicsOptionsDlg::OnZUpTitle() 
{
	m_TitleOvlyZOrderFlags = DDOVERZ_MOVEFORWARD | 0x80000000;
	UpdateData(FALSE);
	OnChange();
}

void CGraphicsOptionsDlg::OnZUpVscroll() 
{
	m_VScrollZOrderFlags = DDOVERZ_MOVEFORWARD | 0x80000000;
	UpdateData(FALSE);
	OnChange();
}

void CGraphicsOptionsDlg::OnZUpHscroll() 
{
	m_HScrollZOrderFlags = DDOVERZ_MOVEFORWARD | 0x80000000;
	UpdateData(FALSE);
	OnChange();
}

void CGraphicsOptionsDlg::OnZDnRgbVid() 
{
	m_RGBVideoZOrderFlags = DDOVERZ_MOVEBACKWARD | 0x80000000;
	UpdateData(FALSE);
	OnChange();
}

void CGraphicsOptionsDlg::OnZDnTitle() 
{
	m_TitleOvlyZOrderFlags = DDOVERZ_MOVEBACKWARD | 0x80000000;
	UpdateData(FALSE);
	OnChange();
}

void CGraphicsOptionsDlg::OnZDnHscroll() 
{
	m_HScrollZOrderFlags = DDOVERZ_MOVEBACKWARD | 0x80000000;
	UpdateData(FALSE);
	OnChange();
}

void CGraphicsOptionsDlg::OnZDnVscroll() 
{
	m_VScrollZOrderFlags = DDOVERZ_MOVEBACKWARD | 0x80000000;
	UpdateData(FALSE);
	OnChange();
}



void CGraphicsOptionsDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);

	UpdateData(TRUE);

	m_AlphaValue = m_AlphaSlider.GetPos();

	UpdateData(FALSE);

	OnChange();
	
}


void CGraphicsOptionsDlg::OnVscrollContent() 
{
	CGraphicsContentDlg dlg;

	dlg.m_Content = m_pCardDlg->pVScrollOvly->m_Content;

	if (dlg.DoModal() == IDOK) {
		m_pCardDlg->pVScrollOvly->m_Content = dlg.m_Content;
	}
}

void CGraphicsOptionsDlg::OnHscrollContent() 
{
	CGraphicsContentDlg dlg;

	dlg.m_Content = m_pCardDlg->pHScrollOvly->m_Content;

	if (dlg.DoModal() == IDOK) {
		m_pCardDlg->pHScrollOvly->m_Content = dlg.m_Content;
	}

}

void CGraphicsOptionsDlg::OnBkgndContent() 
{
	CGraphicsContentDlg dlg;

	dlg.m_Content = m_pCardDlg->PriSurfaceContents;

	if (dlg.DoModal() == IDOK) {
		m_pCardDlg->PriSurfaceContents = dlg.m_Content;
	}
}

void CGraphicsOptionsDlg::OnOvly1Content() 
{
	CGraphicsContentDlg dlg;

	dlg.m_Content = m_pCardDlg->pTitleOvly->m_Content;

	if (dlg.DoModal() == IDOK) {
		m_pCardDlg->pTitleOvly->m_Content = dlg.m_Content;
	}

}

void CGraphicsOptionsDlg::OnChangeAlphaLevel() 
{
	UpdateData(TRUE);
	m_AlphaSlider.SetPos(m_AlphaValue);
	OnChange();

	
}

void CGraphicsOptionsDlg::OnDbgInfo() 
{
	CGraphicDebugInfo dlg;
	dlg.m_pSurface = m_pCardDlg->lpDDSPrimaryRGB;
	dlg.m_pVScrollPos = &m_pCardDlg->DbgVScrollPos;
	dlg.DoModal();
}

void CGraphicsOptionsDlg::OnSavePreset() 
{
	UpdateData(TRUE);

	strcpy(m_pCardDlg->m_szPresetDesc, m_SettingDesc);

	m_pCardDlg->SavePreset(m_pCardDlg->m_ConfigPreset);	
}

